// $Id: ObjectPipe.java,v 1.4 1999/06/23 17:52:05 beca Exp $
/*
File: ObjectPipe.java
Component: Plugin
Date            Author        Changes
Aug 05 98       Lukasz Beca   Created
*/

package webwisdom.tango.beans;



import java.awt.*;

import java.awt.event.*;

import java.beans.*;

import java.applet.*;

import java.util.*;
import java.io.*;



public class ObjectPipe extends Pipe implements java.io.Serializable

{

    String[] recipients;

	public ObjectPipe()

	{

		super();

		recipients = null;


	}

	  



    public synchronized void addPipeDataListener(PipeDataListener tel) {

     

         data_listeners.addElement(tel);

        

    }



    public synchronized void removePipeDataListener(PipeDataListener tel) {



        data_listeners.removeElement(tel);

    }

         

    public void sendData(Object toTango) throws IOException, TangoBeansException {



        sendDataAsObject(toTango);

    }
    
    // latest
    
    public void sendDataOnCondition(Object toTango, boolean condition) throws IOException, TangoBeansException {


        if (condition) {
            sendDataAsObject(toTango);
        }

    }
    
    public void selectiveSendDataOnCondition(Object toTango, boolean condition) throws IOException, TangoBeansException {
        
        
     //   if (recipients == null) throw new NoRecipientsSelectedException();
        
//        if (recipients != null) {
        if (condition) {

            selectiveSendDataAsObject(recipients, toTango);   
        }
  //      } else {
            
  //          System.out.println("ObjectPipe: no recipients selected");               
  //      }          
    }
    

    // end of latest

    public void selectiveSendData(Object toTango) throws IOException, TangoBeansException {
        
        
     //   if (recipients == null) throw new NoRecipientsSelectedException();
        
//        if (recipients != null) {
            selectiveSendDataAsObject(recipients, toTango);   
  //      } else {
            
  //          System.out.println("ObjectPipe: no recipients selected");               
  //      }          
    }
    
    public void selectRecipients(String[] selected) throws TangoBeansException {
        
        recipients = selected;   
    }

    public void receiveData(Object fromTango) {



        PipeDataEvent tse;		

		tse = new PipeDataEvent(this, fromTango);        



        Vector targets;

	    synchronized (this) {

	       targets = (Vector) data_listeners.clone();

	    }		

	    for (int i = 0; i < targets.size(); i++) {

	        PipeDataListener target = (PipeDataListener)targets.elementAt(i);

	        target.dataArrived(tse);

	    }       

    }



    private Vector data_listeners = new Vector();



}