// $Id: DbThread.java,v 1.7 1999/06/23 17:57:11 beca Exp $
/*
File: DbThread.java
Component: Server
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created
*/


package webwisdom.tango.threads;


import java.lang.*;
import java.util.*;
import webwisdom.tango.messages.Message;
import webwisdom.tango.threads.ThreadOut;
import webwisdom.tango.structures.Applications;
import webwisdom.tango.structures.Participants;
import webwisdom.tango.structures.Users;
import webwisdom.tango.structures.DbSessions;
import webwisdom.tango.test.Log;


/**not implemented Server thread.*/
public class DbThread extends Thread
{
    private static final String CL="DbThread";


    Applications apps;
    Participants part;
    Users usr;
    DbSessions dbs;
  

    public DbThread(boolean passwdMode, String passwdFileName)
    {
      super();
      apps = new Applications();
      part = new Participants();
      usr = new Users(passwdMode, passwdFileName);
      dbs = new DbSessions();
    }// DbThread ___________________________________________________________


    public void run()
    {
    Log.out.println(CL+".run()", 2);
      //to be implemented
    }// run ________________________________________________________________


    public synchronized Applications getApplications()
    {
      return apps;
    }


    public synchronized Participants getParticipants()
    {
      return part;
    }


    public synchronized Users getUsers()
    {
      return usr;
    }


    public synchronized DbSessions getSessions()
    {
      return dbs;
    }

    
    public synchronized void wake()
    {
      this.notify();
    }

  
}// DbThread ///////////////////////////////////////////////////////////////

