/***************************************************************************
  FILE: TCrossDataListener.java, TomaszMajor-05May98
  PURPOSE: interface-to-app
  $Id: TCrossDataListener.java,v 1.1 1999/05/05 22:58:30 toma Exp $
  Component: Plugin, Interfaces
***************************************************************************/


package webwisdom.tango;


/**Interface for receiving messages from different sessions.
   *@see TAgent#addTCrossDataListener*/
public interface TCrossDataListener
{


    /**This function is when other session sends something to this session.
       *@see TAgent#getSessionNames
       *@see TAgent#crossSend*/
    public void crossReceive(String sender,byte[] data);


}// TCrossDataListener /////////////////////////////////////////////////////

